/* rotate.c v0.70 */
/* EB = Edward Boone */
/* epsilonbeta@geocities.com */
/* http://www.geocities.com/SiliconValley/Vista/6617/index.html */
/* Only nothing seems to be what it looks like */
/*---------------------------------------------------------------------------*/
/* #include */
#include "effects.h"
/*---------------------------------------------------------------------------*/
#define ROTATE_DELAY_MIN 0
#define ROTATE_DELAY_MAX 3000
#define ROTATE_DELAY_STEP 100

#define ROTATE_SCALE_MIN (ftofix(0.1))
#define ROTATE_SCALE_MAX (ftofix(3))
#define ROTATE_SCALE_STEP (ftofix(0.01))

#define ROTATE_SORT_MIN 1
#define ROTATE_SORT_MAX 4
#define ROTATE_SORT_STEP 1

#define ROTATE_X_MIN 0
#define ROTATE_X_MAX SCREEN_W
#define ROTATE_X_STEP 10

#define ROTATE_Y_MIN 0
#define ROTATE_Y_MAX SCREEN_H
#define ROTATE_Y_STEP 10
/*---------------------------------------------------------------------------*/
/* variables */
fixed angle;

long rotate_delay;
fixed rotate_scale;
int rotate_sort;
int rotate_x;
int rotate_y;

static tkeyparse
  see_f7_0 = {K_0, keysee_f7_0}, /* rotate.c specific */
  see_f7_1 = {K_1, keysee_f7_1},
  see_f7_2 = {K_2, keysee_f7_2},
  see_f7_3 = {K_3, keysee_f7_3},
  see_f7_4 = {K_4, keysee_f7_4},
  see_f7_5 = {K_5, keysee_f7_5},
  see_f7_6 = {K_6, keysee_f7_6},
  see_f7_7 = {K_7, keysee_f7_7},
  see_f7_8 = {K_8, keysee_f7_8},
  see_f7_9 = {K_9, keysee_f7_9},
  see_f7_d = {K_d, keysee_f7_d},
  see_f7_D = {K_D, keysee_f7_D},
  see_f7_s = {K_s, keysee_f7_s},
  see_f7_S = {K_S, keysee_f7_S},
  see_f7_o = {K_o, keysee_f7_o},
  see_f7_O = {K_O, keysee_f7_O},
  see_f7_x = {K_x, keysee_f7_x},
  see_f7_X = {K_X, keysee_f7_X},
  see_f7_y = {K_y, keysee_f7_y},
  see_f7_Y = {K_Y, keysee_f7_Y}
;

tkeyparse* tkeyparsetbl_rotate[] =
{
  TKEYPARSETBL_SEE, /* see.c specific */
  &see_f7_0, /* rotate.c specific */
  &see_f7_1,
  &see_f7_2,
  &see_f7_3,
  &see_f7_4,
  &see_f7_5,
  &see_f7_6,
  &see_f7_7,
  &see_f7_8,
  &see_f7_9,
  &see_f7_d,
  &see_f7_D,
  &see_f7_s,
  &see_f7_S,
  &see_f7_o,
  &see_f7_O,
  &see_f7_x,
  &see_f7_X,
  &see_f7_y,
  &see_f7_Y,
  NULL
};
/*---------------------------------------------------------------------------*/
void keysee_f7_0()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_0", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_1()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_1", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_2()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_2", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_3()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_3", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_4()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_4", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_5()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_5", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_6()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_6", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_7()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_7", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_8()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_8", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_9()
{
  int pi;
  char **tps;

  tps = get_config_argv("[See]", "f7_9", &pi);
  rotate_delay = atoi(tps[1]);
  rotate_scale = ftofix(atof(tps[2]));
  rotate_sort = atoi(tps[3]);
  rotate_x = atoi(tps[4]);
  rotate_y = atoi(tps[5]);
  rotate();
}
/*---------------------------------------------------------------------------*/
void keysee_f7_d()
{
  paralong(&rotate_delay, ROTATE_DELAY_MIN, ROTATE_DELAY_MAX, ROTATE_DELAY_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_D()
{
  paralong(&rotate_delay, ROTATE_DELAY_MIN, ROTATE_DELAY_MAX, ROTATE_DELAY_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_s()
{
  parafixed(&rotate_scale, ROTATE_SCALE_MIN, ROTATE_SCALE_MAX, ROTATE_SCALE_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_S()
{
  parafixed(&rotate_scale, ROTATE_SCALE_MIN, ROTATE_SCALE_MAX, ROTATE_SCALE_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_o()
{
  paraint(&rotate_sort, ROTATE_SORT_MIN, ROTATE_SORT_MAX, ROTATE_SORT_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_O()
{
  paraint(&rotate_sort, ROTATE_SORT_MIN, ROTATE_SORT_MAX, ROTATE_SORT_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_x()
{
  paraint(&rotate_x, ROTATE_X_MIN, ROTATE_X_MAX, ROTATE_X_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_X()
{
  paraint(&rotate_x, ROTATE_X_MIN, ROTATE_X_MAX, ROTATE_X_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_y()
{
  paraint(&rotate_y, ROTATE_Y_MIN, ROTATE_Y_MAX, ROTATE_Y_STEP, 0, 0);
}
/*---------------------------------------------------------------------------*/
void keysee_f7_Y()
{
  paraint(&rotate_y, ROTATE_Y_MIN, ROTATE_Y_MAX, ROTATE_Y_STEP, 1, 0);
}
/*---------------------------------------------------------------------------*/
void rotate()
{
  fixed temp;
  angle = itofix(1);
  lastkey = K_d;
  do
    {
      if (rotate_sort == 1)
	{
	  rotate_scaled_sprite(screen, pbmp, rotate_x, rotate_y, angle, rotate_scale);
	}
      else if (rotate_sort == 2)
	{
	  rotate_scaled_sprite(screen, pbmp, rotate_x, rotate_y, angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp,
			       rotate_x + SCREEN_W - (int)(pbmp->w*fixtof(rotate_scale)),
			       rotate_y, angle, rotate_scale);
	}
      else if (rotate_sort == 3)
	{
	  rotate_scaled_sprite(screen, pbmp, rotate_x, rotate_y, angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp,
			       rotate_x + SCREEN_W - (int)(pbmp->w*fixtof(rotate_scale)),
			       rotate_y, angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp,
			       rotate_x + SCREEN_W - (int)(pbmp->w*fixtof(rotate_scale)),
			       rotate_y + SCREEN_H - (int)(pbmp->h*fixtof(rotate_scale)),
			       angle, rotate_scale);
	}
      else if (rotate_sort == 4)
	{
	  rotate_scaled_sprite(screen, pbmp, rotate_x, rotate_y, angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp,
			       rotate_x + SCREEN_W - (int)(pbmp->w*fixtof(rotate_scale)),
			       rotate_y, angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp,
			       rotate_x + SCREEN_W - (int)(pbmp->w*fixtof(rotate_scale)),
			       rotate_y + SCREEN_H - (int)(pbmp->h*fixtof(rotate_scale)),
			       angle, rotate_scale);
	  rotate_scaled_sprite(screen, pbmp, rotate_x,
			       rotate_y + SCREEN_H - (int)(pbmp->h*fixtof(rotate_scale)),
			       angle, rotate_scale);
	}
      rest(rotate_delay);
      /* trick to avoid assembler message: */
      /* operands given don't match any known 386 instruction */
      temp = itofix(1);
      angle = angle + temp;
      if (angle > itofix(256))
	{
	  angle = temp;
	}
      ptkeyparsetbl = tkeyparsetbl_rotate;
      key_scan();
    }
  while ((lastkey == K_d) || (lastkey == K_D) ||
	 (lastkey == K_s) || (lastkey == K_S) ||
	 (lastkey == K_o) || (lastkey == K_O) ||
	 (lastkey == K_x) || (lastkey == K_X) ||
	 (lastkey == K_y) || (lastkey == K_Y));
  rotate_save();
  if (lastkey == K_ESC)
    {
      esc_hit = 1;
    }
}
/*---------------------------------------------------------------------------*/
void rotate_save()
{
  blit(screen, pbmp, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
}
